unit EditU2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, mwPasSyn, mwCustomEdit, mwHighlighter,
  DcjCppSyn;              

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    mwCustomEdit1: TmwCustomEdit;
    mwPasSyn1: TmwPasSyn;
    Label1: TLabel;
    cbxDelphiSelect: TComboBox;
    Label2: TLabel;
    Button2: TButton;
    Label3: TLabel;
    cbxLanguageSelect: TComboBox;
    DcjCppSyn1: TDcjCppSyn;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbxDelphiSelectChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure mwCustomEdit1Enter(Sender: TObject);
    procedure mwCustomEdit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mwCustomEdit1Change(Sender: TObject);
    procedure cbxLanguageSelectChange(Sender: TObject);
  private
    fName: string;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  ext: string;
begin
  if OpenDialog1.Execute then
  begin
    fName := OpenDialog1.FileName;
    ext := UpperCase(ExtractFileExt(fName));
    if (ext = '.PAS') or (ext = '.INC') then begin
      if cbxLanguageSelect.ItemIndex <> 0 then begin
        cbxLanguageSelect.ItemIndex := 0;
        cbxLanguageSelectChange(Sender);
      end;
    end
    else if (ext = '.C') or (ext = '.CPP') or (ext = '.H') or (ext = '.HPP') then begin
      if cbxLanguageSelect.ItemIndex <> 1 then begin
        cbxLanguageSelect.ItemIndex := 1;
        cbxLanguageSelectChange(Sender);
      end;
    end;
    mwCustomEdit1.Lines.LoadFromFile(fName);
    mwCustomEdit1.SetFocus;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  mwCustomEdit1.MaxUndo := 10;
  cbxLanguageSelect.ItemIndex := 0;
  cbxLanguageSelectChange(Sender);
end;

procedure TForm1.cbxDelphiSelectChange(Sender: TObject);
var
  ok: boolean;
begin
  with cbxDelphiSelect do begin
    ok := mwPasSyn1.UseUserSettings(ItemIndex);
    if ok then Label2.Caption := 'Success!'
          else Label2.Caption := 'Failure!';
    Label2.Show;
    if fName <> '' then begin
      mwCustomEdit1.Invalidate;
      mwCustomEdit1.SetFocus;
    end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   mwCustomEdit1.Undo;
   mwCustomEdit1.SetFocus;
end;

procedure TForm1.mwCustomEdit1Enter(Sender: TObject);
begin
  Button2.Enabled := mwCustomEdit1.CanUndo;
end;

procedure TForm1.mwCustomEdit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Button2.Enabled := mwCustomEdit1.CanUndo;
end;

procedure TForm1.mwCustomEdit1Change(Sender: TObject);
begin
  Button2.Enabled := mwCustomEdit1.CanUndo;
end;

procedure TForm1.cbxLanguageSelectChange(Sender: TObject);
begin
  if cbxLanguageSelect.ItemIndex = 0 
    then mwCustomEdit1.HighLighter := mwPasSyn1
    else mwCustomEdit1.HighLighter := DcjCppSyn1;
  mwCustomEdit1.Invalidate;
  cbxDelphiSelect.Items.Clear;
  mwCustomEdit1.HighLighter.EnumUserSettings(cbxDelphiSelect.Items);
  cbxDelphiSelect.Enabled := (cbxDelphiSelect.Items.Count > 0);
end;

end.

