//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "mwCustomEdit"
#pragma link "DcjCppSyn"
#pragma link "mwPasSyn"
#pragma link "mwHighlighter"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::cmdUndoClick(TObject *Sender)
{
  mwCustomEdit1->Undo();
  mwCustomEdit1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::cmdOpenClick(TObject *Sender)
{
  if( dlgOpen->Execute() ) {
    AnsiString fName = dlgOpen->FileName;
    mwCustomEdit1->Lines->LoadFromFile(fName);
    mwCustomEdit1->SetFocus();
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::cboHighlightChange(TObject *Sender)
{
  if( mwCustomEdit1->HighLighter->UseUserSettings(cboHighlight->ItemIndex) )
    Label2->Caption = "Success!";
  else
    Label2->Caption = "Failure!";

  Label2->Show();

  mwCustomEdit1->Invalidate();
  mwCustomEdit1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::cboLanguageChange(TObject *Sender)
{
  // change the syntax highlighter
  if( cboLanguage->ItemIndex == 0 )
    mwCustomEdit1->HighLighter = mwPasSyn1;
  else
    mwCustomEdit1->HighLighter = DcjCppSyn1;

  // get the new highlight settings for the highlighter selected
  cboHighlight->Items->Clear();
  mwCustomEdit1->HighLighter->EnumUserSettings(cboHighlight->Items);

  mwCustomEdit1->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  mwCustomEdit1->MaxUndo = 10;
  mwCustomEdit1->HighLighter->EnumUserSettings(cboHighlight->Items);
  cboHighlight->Enabled = (cboHighlight->Items->Count > 0);
  cboLanguage->ItemIndex = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mwCustomEdit1Change(TObject *Sender)
{
  cmdUndo->Enabled = mwCustomEdit1->CanUndo;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mwCustomEdit1KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  cmdUndo->Enabled = mwCustomEdit1->CanUndo;  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mwCustomEdit1Enter(TObject *Sender)
{
  cmdUndo->Enabled = mwCustomEdit1->CanUndo;
}
//---------------------------------------------------------------------------
